<?
require_once "do_config.php";
header('Content-Type: application/json');

///////////////////////////////////////////////////////////////////////////

if (getenv('HD_APK') && !getenv('HD_FW_APK')) {
    $log = null;
} else {
    $logpath = "/tmp/plugins/Screenshoter/cgi.log";
    redirect_log_if_needed($logpath);
    $log = fopen($logpath, "a");
}

if (isset($_GET['action']))
	$result = get_action($_GET['action']);
else if (isset($_POST['action'])){
	if (($_POST['action'] == 'del_el')&&(isset($_POST['href']))){
		$tmp = explode(DuneSystem::$properties['plugin_name'], $_POST['href']);
		unlink (DuneSystem::$properties['install_dir_path'] . '/www' . $tmp[1]);
		$result = array('status' => 'ok');
	}
} else {
	$result = array('status' => 'error', 'error' => 'action false!');
}

echo json_encode($result);

if ($log)
    fclose($log);

///////////////////////////////////////////////////////////////////////////

function log_print($str)
{
    global $log;
    if ($log)
        fwrite($log, $str . "\n");
}

function redirect_log_if_needed($path) {
    $size = is_file($path) ? filesize($path) : 0;
    if ($size < 10000)
        return;

    log_print("----------> Redirecting log");
    rename($path, "$path.old");
}

function storage_path() {
    return is_file("/system/dunehd/init") ? "/tmp/mnt/D" : "/D";
}

function imem_path() {
    if (!getenv('HD_APK'))
        return '/sdcard';
    return false != strpos(
        file_get_contents("/config/settings.properties"),
        'show_builtin_memory_item = dunehd_folder') ?
        "/sdcard/DuneHD" : "/sdcard";
}

function get_prop_from_file($path, $name, $def)
{
    if (!is_file($path))
        return $def;

    $res = $def;
    $fp = fopen($path, "r");
    if (!$fp)
        return $def;

    for (;;) {
        $line = fgets($fp);
        if ($line === false)
            break;
        $sep = strpos($line, ' = ');
        if (!$sep)
            continue;

        $key = trim(substr($line, 0, $sep));
        $val = trim(substr($line, $sep + 3));
        if ($key == $name) {
            $res = $val;
            break;
        }
    }

    fclose($fp);
    return $res;
}

function get_action($action){
    $spath = storage_path();
    $ipath = imem_path();
	if (file_exists($spath))
		$path = $spath;
	else if (file_exists($ipath))
		$path = $ipath;
	else
		return array('status' => 'error', 'error' => 'No directories found!');

	if ($path == true){
		$d = get_storage_size($path, 15000);
		if($d['free_space'] != 1)
			return array('status' => 'error', 'error' => $d['str'] . ' free space false!');
		if (!file_exists("$path/screenshots"))
			exec ("mkdir $path/screenshots");
		$path = "$path/screenshots";
	}
	if ($action == 'screenshot'){
        $use_ir_code = getenv('HD_APK') && !getenv('HD_FW_APK');
        if (!$use_ir_code && getenv('HD_FW_APK')) {
            $pstate = get_prop_from_file(
                "/tmp/run/ext_command.state", "player_state", "navigator");
            $astate = (int) get_prop_from_file(
                "/tmp/run/ext_command.android.state", "android_app_active", "0");
            if ($astate == 0 && $pstate == 'file_playback')
                $use_ir_code = 1;
        }
        if ($use_ir_code) {
            $url = "http://".HD::get_ip_address()."/cgi-bin/do?cmd=ir_code&ir_code=ef10bf00";
            $res = HD::http_get_document($url);
            return array('status' => 'ok', 'screenPath' => 'auto');
        } else {
            $screenPath = $path . "/". get_time() .".png";
            log_print("Writing to: $screenPath");
            $prefix = getenv('HD_FW_APK') ? "/system/dunehd/dunehd_service do" : "";
            exec ("$prefix screencap -p $screenPath");
            return array('status' => 'ok', 'screenPath' => $screenPath);
        }
	}else if ($action == 'rec'){
        if (getenv('HD_APK'))
            return array('status' => 'error', 'error' => 'Запись невозможна.');
		$items['screenPath'] = $screenPath = $path . "/". get_time() .".mp4";
		$items['time_start'] = time();
		HD::save_items_tmp('rec_data', $items);
		exec (DuneSystem::$properties['install_dir_path'] . "/bin/rec.sh $screenPath > /dev/null &");// exec ('nohup screenrecord --size 1280x720 '.$screenPath.' &');
		return array('status' => 'ok');
	}else if ($action == 'stop_rec'){
        if (getenv('HD_APK'))
            return array('status' => 'error', 'error' => 'Запись невозможна.');
		$pid = exec ('pidof screenrecord');
		$items = HD::get_items_tmp('rec_data');
		if ($pid == true)
			exec ("kill -2 $pid");
		return array('status' => 'ok', 'screenPath' => $items->screenPath);
	}else if ($action == 'status_rec'){
		$items = HD::get_items_tmp('rec_data');
		$pid = exec ('pidof screenrecord');
		if ($pid == true){
			$tts = 180 - (time() - $items->time_start);
			if ($tts < 0)
				$tts = 0;
			return array('status' => 'rec', 'tts' => $tts);
		}else
			return array('status' => 'stop', 'screenPath' => $items->screenPath);
		
	}else if ($action == 'get_save_content'){
        $spath = storage_path();
        $base = DuneSystem::$properties['install_dir_path'];
		if ((file_exists("$spath/screenshots"))&&(!file_exists("$base/www/dss")))
			exec ("ln -s $spath/screenshots $base/www/dss");
		if (file_exists("$ipath/screenshots")&&
            (!file_exists("$base/www/sdss") || readlink("$base/www/sdss") != "$ipath/screenshots"))
        {
            unlink("$base/www/sdss");
			exec ("ln -s $ipath/screenshots $base/www/sdss");
        }
		$arr = array();
		if (file_exists("$spath/screenshots"))
			$arr = get_files ("$spath/screenshots", 'dss', $arr);
		else if (file_exists("$ipath/screenshots"))
			$arr = get_files ("$ipath/screenshots", 'sdss', $arr);
		$result['screen_collection'] = $arr;
		return $result;
	}else
		return array('status' => 'error', 'error' => 'action unknown!');
}
function get_time (){
	$airDate = exec('date');
	$date = new DateTime($airDate);
	return $date->format('YmdHis');
}
function get_files ($path, $folder, $arr){
	$files = scandir($path);
	$files = array_reverse($files);
	foreach ($files as $v){
		if (preg_match('|\.png$|', $v)){
			$arr[$v]['src']= str_replace('127.0.0.1', HD::get_ip_address_wo_port(), DuneSystem::$properties['plugin_www_url']) ."$folder/$v";
			$arr[$v]['type'] = "img";
		}
		if (preg_match('|\.mp4$|', $v)){
			$arr[$v]['src']= str_replace('127.0.0.1', HD::get_ip_address_wo_port(), DuneSystem::$properties['plugin_www_url']) ."$folder/$v";
			$arr[$v]['type'] = "video";
			$arr[$v]['fake_img'] = str_replace('127.0.0.1', HD::get_ip_address_wo_port(), DuneSystem::$properties['plugin_www_url']) .'/img/video.png';
		}		
	}
	return $arr;
}
function get_storage_size($path, $arg=null){
	$d[0] = disk_free_space($path);
	$d[1] = disk_total_space($path);
	foreach ($d as $bytes){
		$si_prefix = array( 'B', 'KB', 'MB', 'GB', 'TB', 'EB', 'ZB', 'YB' );
		$base = 1024;
		$class = min((int)log($bytes , $base) , count($si_prefix) - 1);
		$size[] = sprintf('%1.2f' , $bytes / pow($base,$class)) . ' ' . $si_prefix[$class];
	}
	if ($arg==true){
		$arr['str'] = $size[0] . '/' . $size[1];
		if ($arg < $d[0])
			$arr['free_space'] = true;
		else
			$arr['free_space'] = false;
		return $arr;
	}
	return $size[0] . '/' . $size[1];
}
